#include <libwccl/ops/logicalpredicate.h>

namespace Wccl {

std::string LogicalPredicate::to_string(const Corpus2::Tagset& tagset) const
{
	std::string s(operator_name(tagset));
	s.append("(");
	BoolFunctionPtrVector::const_iterator it = expressions_->begin();
	while(it != expressions_->end()) {
		s.append((*it)->to_string(tagset));
		if(++it != expressions_->end()) {
			s.append(", ");
		}
	}
	s.append(")");
	return s;
}

std::string LogicalPredicate::to_raw_string() const
{
	std::string s(raw_operator_name());
	s.append("(");
	BoolFunctionPtrVector::const_iterator it = expressions_->begin();
	while(it != expressions_->end()) {
		s.append((*it)->to_raw_string());
		if(++it != expressions_->end()) {
			s.append(", ");
		}
	}
	s.append(")");
	return s;
}

} /* end ns Wccl */
